#include "StdAfx.h"
#include "FavoriteController.h"
#include "ChatUser.h"
#include "NMDropTarget2TreeCtrl.h"
#include <Ole2.h>
#include <fstream>
#include <iostream>
#include "CurrentChatBuddyController.h"
#include "NeMessengerDlg.h"
#include "main_frame.hpp"
const trid_t TRID_PROC_INIT_FAVORITE = 6951;
const trid_t TRID_PROC_EMPLOYEE_INFO = 6952;
const trid_t TRID_PROC_MOVE_BUDDY = 6953;
const trid_t TRID_PROC_SORT_GROUP = 6954;

FavoriteController::FavoriteController(void)
//: m_pBuddyDropTarget(new CNMDropTarget2TreeCtrl())
: m_bImport(FALSE)
, m_ImportGroupCount(0)
, m_pCurrentChatBuddyController(new CCurrentChatBuddyController())
{
	m_pRecentContact = NULL;
	m_bCreatedRecentContactGroup = FALSE;
//	m_favoriteView.SetController(this);
	m_nTridGetBuddy = 0;
	m_pRecentContactBuddyGroup = NULL;
	IGTWASActor *pWASActor = g_pMessengerActor->GetWASActor();
	pWASActor->RegisterObserver(this);
}

FavoriteController::~FavoriteController(void)
{
	{
		CSingleLock lock(&m_csBubbys, TRUE);
		if (!m_Buddys.empty())
		{
			g_pMessengerActor->RequestUregFavoriteFromPOI(REGPOIGROUP_RECENTCONTACTS);
		}
	}
	
	g_pMessengerActor->GetWASActor()->UnRegisterObserver(this);	

	/*if (NULL != m_pBuddyDropTarget) 
		delete m_pBuddyDropTarget;*/
	if (NULL != m_pCurrentChatBuddyController)
		delete m_pCurrentChatBuddyController;
}

/*
void FavoriteController::AddGroup(const IGTBuddyGroup* pGroup, bool bEditLabel)
{	
	if (GetTreeCtrl().GetSafeHwnd() == NULL)
		ASSERT(FALSE);
	
	if (m_ImportGroupVector.empty())
		m_bImport = FALSE;

	if (m_bImport)
		bEditLabel = FALSE;

	const CString strText = GetGroupBuddyCountString(pGroup);
	m_favoriteView.AddGroup(strText, pGroup, bEditLabel);

	//ImportUsers(pGroup);
}
*/
void FavoriteController::AddGroup574(const IGTBuddyGroup* pGroup, bool bEditLabel)
{	
	if (m_ImportGroupVector.empty())
		m_bImport = FALSE;

	if (m_bImport)
		bEditLabel = FALSE;

	const CString strText = GetGroupBuddyCountString(pGroup);
	m_favoriteView.AddGroup574(strText, pGroup, bEditLabel);
}

void FavoriteController::AddRecentContactRroup( CString strGroupName, bool bExpand )
{
	CSingleLock lock(&m_csBubbys);
	lock.Lock();
	if(m_Buddys.size() == 0)
	{
		m_bCreatedRecentContactGroup = FALSE;
		return;
	}
	GT_BUDDY_GROUP_DATA data;
	data.nID = RECENT_CONTACT_GROUP_ID;
	wcscpy(data.strName, strGroupName);
	data.nSortOrder = RECENT_CONTACT_GROUP_SORTORDER;
	m_pRecentContactBuddyGroup = g_pMessengerActor->GetVirtualBuddyGroup(data);

	
	const CString strText = GetRecentContactGroupBuddyCountString(strGroupName);
	m_favoriteView.AddGroup574(strText, m_pRecentContactBuddyGroup, false, bExpand);
	AddRecentContactBuddy(m_Buddys);
	m_bCreatedRecentContactGroup = TRUE;
	lock.Unlock();

	
}

bool FavoriteController::OnGTWASActor_ResponseGetEmployeeInfo(IGTWASActor *pActor, 
															  trid_t trid, 
															  GTWASCallErrorCode eErrorCode, 
															  const NE_MEMBER_DATA_LIST &list, 
															  NTRequestEmpInfoType reqEmpInfoType, 
															  int nGroupID)
{
	if (trid == m_nTridGetBuddy)
	{
		ATLTRACE(TEXT("FavoriteController::OnGTWASActor_ResponseGetEmployeeInfo, add to recent conteant %d\n"),
			list.nSize);
		m_favoriteView.SetEmptyText(LoadStringFromResource(IDS_CHAT_NOBUDDYS)); // No use

		CheckEffectiveBubbys();
		AddRecentContactRroup(LoadStringFromResource(IDS_GROUP_RECENT_CONTACT));
		m_favoriteView.ExpandBuddyGroup();
		vector<std::wstring> vecUsers;
		for (int i = 0; i< list.nSize; i++)
		{
			vecUsers.push_back(list.pList[i].strUserId);
			//UpdateStatus(g_pMessengerActor, list.pList[i].strUserId.c_str());
		}
		if (!vecUsers.empty())
		{
			g_pMessengerActor->RequestRegiFavoriteToPOI(vecUsers, REGPOIGROUP_RECENTCONTACTS);
		}

		return false;
	}
	return true;
}

void FavoriteController::CreateAllGroupItem()
{
	//if (GetTreeCtrl() == NULL)
	//	ASSERT(FALSE);

	size_t nGroupCount = g_pMessengerActor->GetBuddyGroupCount();

	for(size_t i = 0; i < nGroupCount; i++)
	{
		const IGTBuddyGroup *pGroup = g_pMessengerActor->GetBuddyGroupInfoFromIndex(i);			
		AddGroup574(pGroup);
	}
}

void FavoriteController::CreateAllGroupItem574()
{
	size_t nGroupCount = g_pMessengerActor->GetBuddyGroupCount();

	for(size_t i = 0; i < nGroupCount; i++)
	{
		const IGTBuddyGroup *pGroup = g_pMessengerActor->GetBuddyGroupInfoFromIndex(i);			
		AddGroup574(pGroup);
	}
}

BOOL FavoriteController::OnNewRecentContact( CString strContactUserID )
{
	CSingleLock lock(&m_csBubbys);
	lock.Lock();
	 const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfo(static_cast<CString>(strContactUserID));
     if (NULL == pUser)
     {
        pUser = g_pMessengerActor->GetBuddyInfoFromPersist(static_cast<CString>(strContactUserID));
     }
	 ASSERT(pUser);
	 if( NULL == pUser)
	 {
		 return FALSE;
	 }
	 if(!m_bCreatedRecentContactGroup)
	 {
		 m_Buddys.push_back(strContactUserID);
		 vector<wstring> vecUsers;
		 vecUsers.push_back((LPCTSTR)strContactUserID);
		 g_pMessengerActor->RequestRegiFavoriteToPOI(vecUsers, REGPOIGROUP_RECENTCONTACTS);

		 AddRecentContactRroup(LoadStringFromResource(IDS_GROUP_RECENT_CONTACT), true);
		 m_favoriteView.ExpandBuddyGroup();
		 return TRUE;
	 }

	 deque<CString>::iterator it = std::find(m_Buddys.begin(), m_Buddys.end(),strContactUserID);
	 if(m_Buddys.end() == it)
	 {
		 if(m_Buddys.size() > 9)
		 {
			/* vector<wstring> vecUsers;
			 vecUsers.push_back((LPCTSTR)m_Buddys[0]);
			 g_pMessengerActor->RequestUregFavoriteFromPOI(vecUsers, REGPOIGROUP_RECENTCONTACTS);*/
			 RequestUnRegiRecentGroupToPOI((LPCTSTR)m_Buddys[0]);

			 m_favoriteView.DeleteBuddy((CString)m_Buddys[0], RECENT_CONTACT_GROUP_ID);
			 m_Buddys.pop_front();
		 }

		 deque<CString>::iterator it2;
		 for(it2 = m_Buddys.begin(); it2 != m_Buddys.end(); it2++)
		 {
			 m_favoriteView.DeleteBuddy(*it2, RECENT_CONTACT_GROUP_ID);
		 }

		 m_Buddys.push_back(strContactUserID);
		RequestRegiRecentGroupToPOI(strContactUserID);

		 for(deque<CString>::reverse_iterator it3 = m_Buddys.rbegin(); it3 != m_Buddys.rend(); it3++)
		 {
			 const IGTBuddyUser* pInnerUser = g_pMessengerActor->GetBuddyInfo(static_cast<CString>(*it3));
             if (NULL == pInnerUser)
             {
                 pInnerUser = g_pMessengerActor->GetBuddyInfoFromPersist(static_cast<CString>(*it3));
             }
             ASSERT(pInnerUser);
             if (pInnerUser)
             {
                 m_favoriteView.AddBuddy574(pInnerUser, RECENT_CONTACT_GROUP_ID);
             }
		 }
	 }
	 else
	 {	
		 deque<CString>::iterator it2;
		 for(it2 = m_Buddys.begin(); it2 != m_Buddys.end(); it2++)
		 {
			 m_favoriteView.DeleteBuddy(*it2, RECENT_CONTACT_GROUP_ID);
		 }

		 m_Buddys.erase(it);
		 
		 m_Buddys.push_back(strContactUserID);


		 for(deque<CString>::reverse_iterator it3 = m_Buddys.rbegin(); it3 != m_Buddys.rend(); it3++)
		 {
			 const IGTBuddyUser* pInnerUser = g_pMessengerActor->GetBuddyInfo(static_cast<CString>(*it3));
             if (!pInnerUser)
             {
                pInnerUser = g_pMessengerActor->GetBuddyInfoFromPersist(static_cast<CString>(*it3));
             }
             ASSERT(pInnerUser);
             if (pInnerUser)
             {
                 m_favoriteView.AddBuddy574(pInnerUser, RECENT_CONTACT_GROUP_ID);
             }
		 }
	 }

	 UpdateRecentContactGroupName();
	 lock.Unlock();
	 return TRUE;
}


void FavoriteController::AddRecentContactBuddy( deque<CString>& buddys )
{
	/*if (GetTreeCtrl() == NULL) // locked by 574
		ASSERT(FALSE);*/

	list<wstring> listUserIds;

	for(int index = buddys.size() - 1; index >= 0; index--)
	{
		const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfo(static_cast<CString>(buddys[index]));
        if (NULL == pUser)
        {
            pUser = g_pMessengerActor->GetBuddyInfoFromPersist(static_cast<CString>(buddys[index]));
        }
        ASSERT(pUser);
		if(NULL == pUser)
		{
			continue;
		}
		listUserIds.push_back(pUser->GetUserID());

		m_favoriteView.AddBuddy574(pUser, RECENT_CONTACT_GROUP_ID);
	}

	//CUserImageActor::Instance()->RequestUserImages(listUserIds);
}


void FavoriteController::AddBuddy(const IGTBuddyUser* pUser)
{	
	/*if (GetTreeCtrl() == NULL) // locked by 574
		ASSERT(FALSE);*/

	m_favoriteView.AddBuddy574(pUser, pUser->GetGroupID());
	const IGTBuddyGroup *pGroup = g_pMessengerActor->GetBuddyGroupInfo(pUser->GetGroupID());
	UpdateGroupName(pGroup);
}

void FavoriteController::CreateAllBuddyItem()
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	size_t nBuddyCount = g_pMessengerActor->GetBuddyCount();

	list<wstring> listUserIds;
	for (unsigned int index = 0; index < nBuddyCount; index++)
	{
		const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfoFromIndex(index);
		m_favoriteView.AddBuddy574(pUser, pUser->GetGroupID());
		listUserIds.push_back(pUser->GetUserID());	
	}
	//CUserImageActor::Instance()->RequestUserImages(listUserIds);
}

void FavoriteController::CreateAllBuddyItem574()
{
	size_t nBuddyCount = g_pMessengerActor->GetBuddyCount();

	vector<const IGTBuddyUser*> vecIGTBuddyUsr;
    unsigned int index = 0;
	for (  index = 0; index < nBuddyCount; index++)
	{
		const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfoFromIndex(index);
		vecIGTBuddyUsr.push_back(pUser);
	}	

	if (vecIGTBuddyUsr.size() > 1)
	{
		qsort_s(&(vecIGTBuddyUsr.at(0)), vecIGTBuddyUsr.size(), sizeof(IGTBuddyUser*), 
			CAddChatWnd::ItemComareFunc, this);	
	}
	
	for (index = 0; index < vecIGTBuddyUsr.size(); index++)
    {
       const IGTBuddyUser* pUser = vecIGTBuddyUsr.at(index);
       m_favoriteView.AddBuddy574(pUser, pUser->GetGroupID());
    }

	m_favoriteView.UpdataAllBuddyImage();

}

// ֱٴȭ ׷ [2012/10/15/ yangjae.park@nhn.com]
void FavoriteController::CreateCurrentChatGroup()
{

}

// ֱٴȭ  [2012/10/15/ yangjae.park@nhn.com]
void FavoriteController::CreateCurrentChatBuddyList()
{

}


// ã⸮Ʈ ʱȭ
void FavoriteController::InitFavoriteList()
{	

	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);
	//  ֱٴȭ븦 ´. [2012/10/15/ yangjae.park@nhn.com]
	m_pCurrentChatBuddyController->LoadCurrentBuddy();

	m_favoriteView.DeleteAllItems();
	
	m_pRecentContact = GET_MESSENGER_DLG()->GetMainFrame()->GetRecentContacts();

	CString strMyUserId = GetMyUserID();

	CSingleLock lock(&m_csBubbys);
	lock.Lock();
	m_Buddys.clear();
	m_bCreatedRecentContactGroup = FALSE;
	m_pRecentContact->GetAllContactByUserId(strMyUserId, &m_Buddys);

	const wchar_t* sperator = L"|";
	CStringW strUserID;
	for (int i = 0; i< m_Buddys.size(); i++)
	{
		if (!strUserID.IsEmpty())
		{
			strUserID += sperator;
		}
		strUserID += m_Buddys[i];
	}
	if (!strUserID.IsEmpty())
	{
		g_pMessengerActor->GetWASActor()->RequestEmplyeeInfo(strUserID, GetLanguageStringUnicode(), reitSingleTrans, &m_nTridGetBuddy);
	}
	else
	{
		m_favoriteView.SetEmptyText(LoadStringFromResource(IDS_CHAT_NOBUDDYS));
	}
	
	lock.Unlock();

	CreateAllGroupItem();
	CreateAllBuddyItem();


	//ħ  ´.
	m_favoriteView.ExpandBuddyGroup();

	// ׷ ħ ·  ExpandGroup ȣѴ. [2012.5.11 yangjae.park@nhn.com]
}

list<wstring> FavoriteController::GetRecentContactUsers()
{
	list<wstring> listRet;
	for(deque<CString>::iterator it = m_Buddys.begin(); it != m_Buddys.end(); it++)
	{
		wstring strUserId = (LPCTSTR)(*it);
		listRet.push_back(strUserId);
	}

	return listRet;
}

void FavoriteController::InitFavoriteList574()
{	
	//  ֱٴȭ븦 ´. [2012/10/15/ yangjae.park@nhn.com]
	m_pCurrentChatBuddyController->LoadCurrentBuddy();

	m_favoriteView.DeleteAllItems();

	m_pRecentContact = GET_MESSENGER_DLG()->GetMainFrame()->GetRecentContacts();

	CString strMyUserId = GetMyUserID();

	CSingleLock lock(&m_csBubbys);
	lock.Lock();
	m_Buddys.clear();
	m_bCreatedRecentContactGroup = FALSE;
	m_pRecentContact->GetAllContactByUserId(strMyUserId, &m_Buddys);

	const wchar_t* sperator = L"|";
	CStringW strUserID;
	for (int i = 0; i< m_Buddys.size(); i++)
	{
		if (!strUserID.IsEmpty())
		{
			strUserID += sperator;
		}
		strUserID += m_Buddys[i];
	}
	if (!strUserID.IsEmpty())
	{
		g_pMessengerActor->GetWASActor()->RequestEmplyeeInfo(strUserID, GetLanguageStringUnicode(), reitSingleTrans, &m_nTridGetBuddy);
	}
	else
	{
		m_favoriteView.SetEmptyText(LoadStringFromResource(IDS_CHAT_NOBUDDYS));
	}

	lock.Unlock();

	CreateAllGroupItem574();
	CreateAllBuddyItem574();
    
	

/*
	size_t nGroupCount = g_pMessengerActor->GetBuddyGroupCount();
	for (int index = 0; index < nGroupCount; index++)
	{
		const IGTBuddyGroup* pUser = g_pMessengerActor->GetBuddyGroupInfoFromIndex(index);
		int gid = pUser->GetID();
		ResortBuddyInGroup(gid);
	}*/

	//ħ  ´.
	m_favoriteView.ExpandBuddyGroup();// locked by 574

	// ׷ ħ ·  ExpandGroup ȣѴ. [2012.5.11 yangjae.park@nhn.com]
}


void FavoriteController::ClearFavoriteList()
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	m_favoriteView.DeleteAllItems();
}

void FavoriteController::InitView(CWnd* pParentWnd)
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	//SetOleDropTarget();
}

void FavoriteController::SetList(CBuddyTreeCtrl* pBuddyList)
{
	m_favoriteView.SetList(pBuddyList);
	m_favoriteView.SetController(this);
}

std::vector<Node*> FavoriteController::GetSelectedBuddyItems(void)
{
	//if (GetTreeCtrl() == NULL)
	//	ASSERT(FALSE);

	std::vector<Node*> vecSelectedItem;
	vecSelectedItem=m_favoriteView.SelectedBuddyItems();
	
	return vecSelectedItem;
}

const std::vector<Node*> FavoriteController::GetSelectedItems(void)
{

	//if (GetTreeCtrl() == NULL)
	//	ASSERT(FALSE);

	std::vector<Node*> vecSelectedItems = m_favoriteView.GetSelectedItems();
	return vecSelectedItems;
}
const CString FavoriteController::GetItemDisplayText(const IGTBuddyUser* pUser)
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	CString strRet;
	strRet= m_favoriteView.GetItemDisplayText(pUser);
	return strRet;
}
const CString FavoriteController::GetItemWorkStatusText( const IGTBuddyUser* pUser )
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	CString strRet;
	strRet= m_favoriteView.GetItemWorkStatusText(pUser);
	return strRet;

}


int FavoriteController::GetSelectedBuddyItems(std::vector<const IGTBuddyUser*>& buddyUserVector,
											  bool bUniqueUserID)
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	const std::vector<const IGTBuddyUser *> selectedItems = m_favoriteView.SelectedBuddyUsers();
	if( selectedItems.empty() )
		return 0;

	std::vector<const IGTBuddyUser *>::const_iterator itemIterator = selectedItems.begin();
	for (; itemIterator != selectedItems.end(); ++itemIterator)
	{
		const IGTBuddyUser* pUser = *itemIterator;
		
		if(bUniqueUserID)
		{
			if (IsNotInBuddyVector(buddyUserVector, pUser->GetUserID()))
			{
				buddyUserVector.push_back(pUser);
			}
		}
		else
		{
			if (IsNotInBuddyVector(buddyUserVector, pUser->GetID()))
			{
				buddyUserVector.push_back(pUser);
			}
		}
	}

	return buddyUserVector.size();
}

int FavoriteController::GetSelectedGroupItems(std::vector<const IGTBuddyGroup*>& groupVector)
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	const std::vector<const IGTBuddyGroup *> selectedItems = m_favoriteView.SelectedGroups();
	if( selectedItems.empty() )
		return 0;

	std::vector<const IGTBuddyGroup *>::const_iterator itemIterator = selectedItems.begin();
	for (; itemIterator != selectedItems.end(); ++itemIterator)
	{
		const IGTBuddyGroup* pUser = *itemIterator;

		groupVector.push_back(pUser);
	}

	return groupVector.size();
}

int FavoriteController::GetAllGroupItems(std::vector<const IGTBuddyGroup*>& groupVector)
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	const std::vector<const IGTBuddyGroup *> selectedItems = m_favoriteView.AllGroups();
	if( selectedItems.empty() )
		return 0;

	std::vector<const IGTBuddyGroup *>::const_iterator itemIterator = selectedItems.begin();
	for (; itemIterator != selectedItems.end(); ++itemIterator)
	{
		const IGTBuddyGroup* pUser = *itemIterator;

		groupVector.push_back(pUser);
	}

	return groupVector.size();
}

int FavoriteController::GetSelectedFavoritesCount()
{
	if (GetTreeCtrl() == NULL) // blocked by 574
		return 0;

	std::vector<const IGTBuddyUser*> buddyUserVector;
	return GetSelectedBuddyItems(buddyUserVector);
}

int FavoriteController::GetSelectedOnlineFavorites( std::vector<const IGTBuddyUser*>& buddyUserVector )
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	const std::vector<const IGTBuddyUser *> selectedItems = m_favoriteView.SelectedBuddyUsers();
	if( selectedItems.empty() )
		return 0;

	std::vector<const IGTBuddyUser *>::const_iterator itemIterator = selectedItems.begin();
	for (; itemIterator != selectedItems.end(); ++itemIterator)
	{
		const IGTBuddyUser* pUser = *itemIterator;
		if (pUser->IsOnline() && IsNotInBuddyVector(buddyUserVector, pUser->GetUserID()))
		{
			buddyUserVector.push_back(pUser);
		}
	}

	return buddyUserVector.size();
}

int FavoriteController::GetSelectedOnlineFavoritesCount()
{
	if (GetTreeCtrl() == NULL)
		return 0;

	std::vector<const IGTBuddyUser*> buddyUserVector;
	return GetSelectedOnlineFavorites(buddyUserVector);
}

void FavoriteController::MoveView(LPRECT lpRect)
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	m_favoriteView.Move(lpRect);
}

//BOOL FavoriteController::IsOnlineSelected() const
//{
//	bool bReturn = false;
//
//	const IGTBuddyUser* pUser = m_favoriteView.GetSelectedBuddy();
//	if (pUser != NULL)
//	{
//		bReturn = pUser->IsOnline();
//	}
//	return bReturn;
//}

BOOL FavoriteController::IsGroupSelected() const
{
	return m_favoriteView.IsGroupSelected();
}

void FavoriteController::MoveBuddy( int nFromGroupID, const IGTBuddyUser* pUser )
{
	/*if (GetTreeCtrl() == NULL) // blocked by 574
		ASSERT(FALSE);*/

	DeleteBuddy(pUser->GetUserID(),nFromGroupID);
	AddBuddy(pUser);
}

int FavoriteController::HitTestGroupId()
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	int groupId = m_favoriteView.HitTestGroupId();
	return groupId;
}

//int FavoriteController::GetSelectedTargetGroupID()
//{
//	if (GetTreeCtrl() == NULL)
//		ASSERT(FALSE);
//
//	int groupId = -1;
//
//	const IGTBuddyGroup* pGroup = m_favoriteView.GetSelectedGroup();
//	if (pGroup != NULL)
//	{
//		groupId = pGroup->GetID();
//	}
//	else
//	{	
//		const IGTBuddyUser* pUser = m_favoriteView.GetSelectedBuddy();
//		if (pUser != NULL)
//		{
//			groupId = pUser->GetGroupID();
//		}
//		else
//		{
//		}
//	}
//	return groupId;
//}

const CString FavoriteController::GetNewGroupName(const CString strDefaultName)
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	CString strGroupName;	

	int idx = 0;
	strGroupName = strDefaultName;
	while(1)
	{
		if(g_pMessengerActor->GetBuddyGroupInfo(strGroupName) == NULL)
		{
			break;
		}		
		strGroupName.Format(_T("%s (%d)"), strDefaultName, ++idx);		// ׷(0)...				
	}

	return strGroupName;		
}


bool FavoriteController::IsExistGroup(LPCWSTR strUserID, int nGroupID)
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	bool bRet=m_favoriteView.IsExistGroup(strUserID,nGroupID);

	return bRet;
}
BOOL FavoriteController::RequestAddGroup()
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	bool returnResult = false;
	
	int nGroupCnt = g_pMessengerActor->GetBuddyGroupCount();

	if(nGroupCnt >= MAX_GROUP)
	{	
		CString strMaxGroupCnt;
		strMaxGroupCnt.Format(IDS_STRING227,MAX_GROUP);
		NMessageBox(AfxGetMainWnd(), strMaxGroupCnt);
	}
	else
	{
		CString strDefaultName = LoadStringFromResource(IDS_STRING444);
		const CString groupName = GetNewGroupName(strDefaultName);
		if(g_pMessengerActor->RequestAddBuddyGroup(groupName, buddyGroupAction_Favorite) == false)
		{
			NTALK_LOG->Debug(L"[BUDDY] RequestAddBuddyGroup(%s, %d) Failed", groupName, buddyGroupAction_Favorite);
			NMessageBox(AfxGetMainWnd(), LoadStringFromResource(IDS_STRING445));
		}
		else
		{
			NTALK_LOG->Debug(L"[BUDDY] RequestAddBuddyGroup(%s, %d) Succeeded", groupName, buddyGroupAction_Favorite);
			returnResult = true;
		}

		CString strDbg;
		strDbg.Format(_T("\r\n######[ProcDelGroup] : groupname :%s"), groupName);
		OutputDebugString(strDbg);	
	}

	return returnResult;
}

//BOOL FavoriteController::RequestImportGroup( const CString strGroupName )
//{
//	BOOL returnResult = TRUE;
//
//	int nGroupCnt = g_pMessengerActor->GetBuddyGroupCount();
//
//	if(nGroupCnt >= MAX_GROUP)
//	{	
//		CString strMaxGroupCnt;
//		strMaxGroupCnt.Format(IDS_STRING227,MAX_GROUP);
//		NMessageBox(AfxGetMainWnd(), strMaxGroupCnt);
//		returnResult = FALSE;
//	}
//	else
//	{
//		if(g_pMessengerActor->RequestAddBuddyGroup(strGroupName, buddyGroupAction_Favorite) == false)
//		{
//			returnResult = FALSE;
//		}
//	}
//
//	return returnResult;
//}

void FavoriteController::EditLableOn( const IGTBuddyGroup * pGroup /*= NULL*/ )
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	if (pGroup)
	{
		m_favoriteView.EditGroupLabelOn(pGroup->GetID());
	}
	else
	{
		m_favoriteView.EditGroupLabelOn();
	}
}

void FavoriteController::UpdateRecentContactGroupName()
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	if(m_Buddys.size() == 0)
	{
		m_favoriteView.DeleteGroup(RECENT_CONTACT_GROUP_ID);
		m_bCreatedRecentContactGroup = FALSE;
		return;
	}
	CString displayText = GetRecentContactGroupBuddyCountString(m_pRecentContactBuddyGroup->GetName());
	m_favoriteView.UpdateGroupName(m_pRecentContactBuddyGroup, displayText);
}

void FavoriteController::UpdateGroupName(const IGTBuddyGroup* pGroup)
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	if (NULL == pGroup)
		return;

	CString displayText = GetGroupBuddyCountString(pGroup);
	m_favoriteView.UpdateGroupName(pGroup, displayText);
}

void FavoriteController::MenuMoveBuddy(UINT nCmdID, int nMenuStartID  )
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	m_favoriteView.MenuMoveBuddy(nCmdID, nMenuStartID);
}
void FavoriteController::MenuCopyBuddy(UINT nCmdID, int nMenuStartID )
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	m_favoriteView.MenuCopyBuddy(nCmdID, nMenuStartID);
}
void FavoriteController::RequestDeleteGroup(const IGTBuddyGroup* pGroup /*=NULL*/)
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	if (pGroup == NULL)
	{
		pGroup = m_favoriteView.GetSelectedGroup();
	}
	ASSERT(pGroup != NULL);
	if (pGroup == NULL)
	{
		ASSERT(FALSE);
	}

	int nGroupId = pGroup->GetID();
	
	CString strDbg;
	strDbg.Format(_T("\r\n######[ProcDelGroup] : groupid :%d"), nGroupId);
	OutputDebugString(strDbg);

	CString strMsg = _T("");	
	strMsg.Format(IDS_STRING228, pGroup->GetName());

	if(NMessageBox(AfxGetMainWnd(), strMsg, _T(""), MB_OKCANCEL ) != IDOK)
		return;

	
	if(g_pMessengerActor->RequestDelBuddyGroup(nGroupId) == false)
	{
		NTALK_LOG->Debug(L"[BUDDY] RequestDelBuddyGroup(%d) Failed", nGroupId);
		NMessageBox(AfxGetMainWnd(),LoadStringFromResource(IDS_STRING446));
	}
	else
		NTALK_LOG->Debug(L"[BUDDY] RequestDelBuddyGroup(%d) Succeeded", nGroupId);
}

void FavoriteController::DeleteGroup(int nGroupID)
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	m_favoriteView.DeleteGroup(nGroupID);
	NMessageBox(AfxGetMainWnd(),LoadStringFromResource(IDS_STRING447));
}

void FavoriteController::DeleteBuddy(LPCWSTR strUserId, int nGroupId)
{
	/*if (GetTreeCtrl() == NULL) // blocked by 574
		ASSERT(FALSE);*/

	m_favoriteView.DeleteBuddy(strUserId, nGroupId);
	const IGTBuddyGroup *pGroup = g_pMessengerActor->GetBuddyGroupInfo(nGroupId);
	UpdateGroupName(pGroup);
	GET_APP()->m_pChatDialogManager->RemoveBuddy(strUserId);
}

trid_t FavoriteController::GetTrid() const
{

	return TRID_PROC_INIT_FAVORITE;
}

std::vector<std::wstring> FavoriteController::GetTargetGroupNameList( int nGroupID /*= -1*/ )
{
    //according current Implementation, there are too many unused and incomplete code, so block it now
    ASSERT(0 == nGroupID); 
	if (GetTreeCtrl() == NULL)
    {
		ASSERT(FALSE);
    }
	std::vector<std::wstring> groupNameList;

	//if (nGroupID == -1)
	//{
	//	nGroupID = GetSelectedTargetGroupID();
	//}

	if (nGroupID ==0)
	{
		size_t nGroupCount = g_pMessengerActor->GetBuddyGroupCount();
		for(size_t i = 0; i < nGroupCount; i++)
		{
			const IGTBuddyGroup *pGroup = g_pMessengerActor->GetBuddyGroupInfoFromIndex(i);		
			LPCWSTR strGroupName = pGroup->GetName();	
			groupNameList.push_back(strGroupName);		
		}
	}
	//else if (nGroupID > 0)
	//{
	//	size_t nGroupCount = g_pMessengerActor->GetBuddyGroupCount();
	//	for(size_t i = 0; i < nGroupCount; i++)
	//	{
	//		const IGTBuddyGroup *pGroup = g_pMessengerActor->GetBuddyGroupInfoFromIndex(i);		
	//		if (pGroup->GetID() != nGroupID)
	//		{
	//			LPCWSTR strGroupName = pGroup->GetName();	
	//			groupNameList.push_back(strGroupName);		
	//		}
	//	}
	//}

	return groupNameList;
}

std::vector<int> FavoriteController::GetTargetGroupIdList( int nGroupID /*= -1*/ )
{
    //according current Implementation, there are too many unused and incomplete code, so block it now
    ASSERT(0 == nGroupID); 

    if (GetTreeCtrl() == NULL)
    {
		ASSERT(FALSE);
    }
	std::vector<int> groupIDList;
	//if (nGroupID == -1)
	//{
	//	nGroupID = GetSelectedTargetGroupID();
	//}
	if (nGroupID ==0)
	{
		size_t nGroupCount = g_pMessengerActor->GetBuddyGroupCount();
		for(size_t i = 0; i < nGroupCount; i++)
		{
			const IGTBuddyGroup *pGroup = g_pMessengerActor->GetBuddyGroupInfoFromIndex(i);		
			int nTargetGroupID = pGroup->GetID();
			groupIDList.push_back(nTargetGroupID);		
		}
	}
	//else if (nGroupID > 0)
	//{
	//	size_t nGroupCount = g_pMessengerActor->GetBuddyGroupCount();
	//	for(size_t i = 0; i < nGroupCount; i++)
	//	{
	//		const IGTBuddyGroup *pGroup = g_pMessengerActor->GetBuddyGroupInfoFromIndex(i);		
	//		int nTargetGroupID = pGroup->GetID();
	//		if (nTargetGroupID != nGroupID)
	//		{
	//		
	//			groupIDList.push_back(nTargetGroupID);		
	//		}
	//	}
	//}

	return groupIDList;
}

void FavoriteController::RequestDeleteBuddy()
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	std::vector<const IGTBuddyUser* > buddyVector;
	GetSelectedBuddyItems(buddyVector, false);

	RequestDeleteBuddy(buddyVector);
}

void FavoriteController::RequestDeleteBuddy(std::vector<const IGTBuddyUser*> &vecSelectedBuddy)
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	ProcDelFavorite(vecSelectedBuddy);
}

//ģ ν
int FavoriteController::ProcDelFavorite(std::vector<const IGTBuddyUser*> &vecSelectedBuddy)
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	std::vector<int> vecBuddyIntID;
	for( std::vector<const IGTBuddyUser*>::iterator itr = vecSelectedBuddy.begin(); itr != vecSelectedBuddy.end(); itr++ )
		vecBuddyIntID.push_back((*itr)->GetID());

	if( vecBuddyIntID.empty() != true )
	{
		if(g_pMessengerActor->RequestDelBuddy(vecBuddyIntID) == false)
		{
			NTALK_LOG->Debug(L"[BUDDY] RequestDelBuddy(%d) Failed", vecBuddyIntID.size());
			NMessageBox(AfxGetMainWnd(), LoadStringFromResource(IDS_STRING448));
		}
		else
			NTALK_LOG->Debug(L"[BUDDY] RequestDelBuddy(%d) Succeeded", vecBuddyIntID.size());
	}

	return 0;
}

// ģ߰ ν
BOOL FavoriteController::RequestAddBuddy( int nGroupId, std::vector<wstring> vecBuddyID )
{	

	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

/*
	CString str;
	for( std::vector<wstring>::iterator itr = vecBuddyID.begin(); itr != vecBuddyID.end(); itr++ )
	{
		str.AppendFormat(L"%s; ",(*itr).c_str());
	}*/

	if(g_pMessengerActor->RequestAddBuddy(nGroupId, vecBuddyID, _T("")) == false)
	{
		NTALK_LOG->Debug(L"[BUDDY] RequestAddBuddy(%d, %d) Failed", nGroupId, vecBuddyID.size());
		NMessageBox(AfxGetMainWnd(),LoadStringFromResource(IDS_STRING_NEMSGDLG_ALERT_ALREADYADDEDBUDDY));
		return FALSE;
	}
	else
		NTALK_LOG->Debug(L"[BUDDY] RequestAddBuddy(%d, %d) Succeeded", nGroupId, vecBuddyID.size());

	return TRUE;
}

void FavoriteController::UpdateStatus(IGTMessengerActor *pActor, LPCWSTR strBuddyID)
{
	CSingleLock lock(&m_csBubbys);
	lock.Lock();
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	const IGTBuddyUser* pUser = pActor->GetBuddyInfo(strBuddyID);
	if(pUser == NULL)
	{
		pUser = pActor->GetBuddyInfoFromPersist(strBuddyID);
	}
	
	const NE_MEMBER_DATA* data = pActor->GetEmployeeInfo(strBuddyID);
	if(NULL!=pUser && NULL != data)
    {
		m_favoriteView.UpdateStaus(strBuddyID,pUser, data);
    }
	lock.Unlock();
}
bool FavoriteController::RequestSortGroup(std::vector<GT_BUDDY_GROUP_DATA> &vecGroupData){
	if (GetTreeCtrl() == NULL)
	{
		ASSERT(FALSE);
	}

	if (vecGroupData.size() <=0 )
		return false;

	trid_t trid(TRID_PROC_SORT_GROUP);
	

	if(g_pMessengerActor->RequestUpdateBuddyGroupSortOrder(vecGroupData,  &trid) == false)
	{
		ASSERT(FALSE);
		return false;
	}
	return true;
}
// ģ ̵
bool FavoriteController::RequestMoveBuddy( std::vector<int> &vecBuddyID, int nToGroupId/*, std::vector<int> &vecDelBuddyID*/ )
{
	if (GetTreeCtrl() == NULL)
	{
		ASSERT(FALSE);
	}

	if (vecBuddyID.size() <=0 )
		return false;

	trid_t trid(TRID_PROC_MOVE_BUDDY);

	if(g_pMessengerActor->RequestMoveBuddy(vecBuddyID, nToGroupId, &trid) == false)
	{
		//ASSERT(FALSE);
		NTALK_LOG->Debug(L"[BUDDY] RequestMoveBuddy(%d, %d) Failed", nToGroupId, vecBuddyID.size());
		return false;
	}
	else
		NTALK_LOG->Debug(L"[BUDDY] RequestMoveBuddy(%d, %d) Succeeded", nToGroupId, vecBuddyID.size());

	return true;
}


const std::vector<const IGTBuddyUser*> FavoriteController::GetGroupOnlineBuddyList( const IGTBuddyGroup* pGroup )
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	int onlineCount = 0;
	int nGroupId = pGroup->GetID();
	int buddyCount = g_pMessengerActor->GetBuddyCount(nGroupId);

	std::vector<const IGTBuddyUser*> buddyVector;
	for (int index = 0; index < buddyCount; index++)
	{
		const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfoFromIndex(nGroupId, index);

		if (pUser->IsOnline() && IsNotInBuddyVector(buddyVector, pUser->GetUserID()))
		{
			buddyVector.push_back(pUser);
		}
	}

	return buddyVector;
}


int FavoriteController::GetRecentContactGroupOnlineBuddyCount()
{
	if (GetTreeCtrl() == NULL) // locked by 574
		ASSERT(FALSE);

	int onlineCount = 0;

	for (int index = 0; index < m_Buddys.size(); index++)
	{
	   const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfo((m_Buddys)[index]);
	   if(NULL == pUser)
       {
           pUser = g_pMessengerActor->GetBuddyInfoFromPersist((m_Buddys)[index]);
	   }
       //ASSERT(pUser);
       if (pUser)
       {
           if (pUser->IsOnline())
           {
               onlineCount++;
           }
       }
	}

	return onlineCount;
}

int FavoriteController::GetGroupOnlineBuddyCount( const IGTBuddyGroup* pGroup )
{
	if (GetTreeCtrl() == NULL) 
	{
		ASSERT(FALSE);
	}


	int onlineCount = 0;
	int nGroupId = pGroup->GetID();
	int buddyCount = g_pMessengerActor->GetBuddyCount(nGroupId);

	for (int index = 0; index < buddyCount; index++)
	{
		const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfoFromIndex(nGroupId, index);
		if(NULL == pUser)
		{
			continue;
		}
		if (pUser->IsOnline())
		{
			onlineCount++;
		}
	}

	return onlineCount;
}

const CString FavoriteController::GetRecentContactGroupBuddyCountString(const CString& strGroupName)
{
	if (GetTreeCtrl() == NULL) // locked by 574
		ASSERT(FALSE);

	//const wchar_t startBracket = L'[';
	//const wchar_t endBracket = L']';
	//const wchar_t delemeter = L'/';

	int onlienCount = GetRecentContactGroupOnlineBuddyCount();
	int buddyCount = m_Buddys.size();
	CString displayText;
	displayText.Format(_T("%s(%d/%d)"), strGroupName, onlienCount, buddyCount);

	return displayText;
}

const CString FavoriteController::GetGroupBuddyCountString( const IGTBuddyGroup* pGroup )
{
	if (NULL == pGroup)
		return L"";
	if (GetTreeCtrl() == NULL) // locked by 574
		ASSERT(FALSE);

	//const wchar_t startBracket = L'[';
	//const wchar_t endBracket = L']';
	//const wchar_t delemeter = L'/';

	int onlienCount = GetGroupOnlineBuddyCount(pGroup);
	int buddyCount = g_pMessengerActor->GetBuddyCount(pGroup->GetID());
	CString displayText;
	displayText.Format(_T("%s(%d/%d)"), pGroup->GetName(), onlienCount, buddyCount);

	return displayText;
}

const std::vector<const IGTBuddyUser*> FavoriteController::GetGroupBuddyList( const IGTBuddyGroup* pGroup )
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	int nGroupId = pGroup->GetID();
	int buddyCount = g_pMessengerActor->GetBuddyCount(nGroupId);

	std::vector<const IGTBuddyUser*> buddyVector;
	for (int index = 0; index < buddyCount; index++)
	{
		const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfoFromIndex(nGroupId, index);

		buddyVector.push_back(pUser);
	}

	return buddyVector;
}

int FavoriteController::GetGroupBuddyCount(const IGTBuddyGroup* pGroup)
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	return g_pMessengerActor->GetBuddyCount(pGroup->GetID());
}


int FavoriteController::GetRecentContactGroupBuddyCount()
{
	return m_Buddys.size();
}


BOOL FavoriteController::IsBuddySelected() const
{
	return m_favoriteView.IsBuddySelected();
}

void FavoriteController::UpdateAllBuddyDisplayNames()
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	m_favoriteView.UpdateAllBuddyDisplayNames();
}

void FavoriteController::SetOleDropTarget()
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	/*if (NULL == m_pBuddyDropTarget)
		return;*/

	UINT nClipboardFormat = RegisterClipboardFormat(_T("CF_NTALK_ID"));
/*
	m_pBuddyDropTarget->Register(&m_favoriteView.GetWindowHandle());
	m_pBuddyDropTarget->setClipBoardFormat(nClipboardFormat);*/
}

void FavoriteController::CarryDragDrop(HGLOBAL hGlobal)
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	COleDataSource oleDataSource;
	UINT nClipboardFormat = RegisterClipboardFormat(_T("CF_NTALK_ID"));
	oleDataSource.CacheGlobalData(nClipboardFormat, hGlobal);
	oleDataSource.DoDragDrop();
}

bool FavoriteController::IsNotInBuddyVector( std::vector<const IGTBuddyUser*> &buddyUserVector, int nID )
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	bool result = true;

	if(buddyUserVector.empty() == true)
		true;

	std::vector<const IGTBuddyUser *>::const_iterator itemIterator = buddyUserVector.begin();
	for (; itemIterator != buddyUserVector.end(); ++itemIterator)
	{
		const IGTBuddyUser* pVectorUser = *itemIterator;

		if (nID == pVectorUser->GetID())
		{
			result = false;
			break;
		}
	}

	return result;
}

bool FavoriteController::IsNotInBuddyVector( std::vector<const IGTBuddyUser*> &buddyUserVector, CString strUserID )
{
	if (GetTreeCtrl() == NULL)
		ASSERT(FALSE);

	bool result = true;

	if(buddyUserVector.empty() == true)
		true;

	std::vector<const IGTBuddyUser *>::const_iterator itemIterator = buddyUserVector.begin();
	for (; itemIterator != buddyUserVector.end(); ++itemIterator)
	{
		const IGTBuddyUser* pVectorUser = *itemIterator;

		if (0 == strUserID.CompareNoCase(pVectorUser->GetUserID()))
		{
			result = false;
			break;
		}
	}

	return result;
}

BOOL FavoriteController::IsMyUserID(LPCWSTR strID)
{
	wstring strUserID = GetMyUserID();

	return strUserID.compare(strID) == 0 ? TRUE : FALSE;
}

void FavoriteController::ExportGroup( std::vector<const IGTBuddyGroup* > groupVector, CString exportDefaultName, HWND hParentWnd )
{
	int nGroupCount = groupVector.size();

	if (1 > nGroupCount)
		return;

	//Get File Name
	const CString strExportFileName = GetExportFileName(FALSE, exportDefaultName, hParentWnd);

	if (strExportFileName.IsEmpty())
		return;

	ofstream ofs(strExportFileName, ios::binary);
	ofs.write((char*)&(nGroupCount), sizeof(int));

	BOOL bFirst = TRUE;
	std::vector<const IGTBuddyGroup *>::const_iterator itemIterator = groupVector.begin();
	for (; itemIterator != groupVector.end(); ++itemIterator)
	{
		const IGTBuddyGroup* pGroup = *itemIterator;

		if (NULL != pGroup)
		{
			//׷ 
			int nLength = WideCharToMultiByte( CP_ACP, 0, pGroup->GetName(), -1, NULL, 0, NULL, NULL );

			char *buffer = new char[nLength + 1];
			WideCharToMultiByte( CP_ACP, 0, pGroup->GetName(), -1, buffer, nLength, NULL, NULL );

			ofs.write((char*)&(nLength), sizeof(int));
			ofs.write(buffer, nLength);
			delete [] buffer;

			//׷쳻  
			int nCount = g_pMessengerActor->GetBuddyCount(pGroup->GetID());
			if (bFirst)
			{
				int newcount = nCount + 1;
				ofs.write((char*)&(newcount), sizeof(int));
			}
			else
			{
				ofs.write((char*)&(nCount), sizeof(int));
			}

			
			if (bFirst)
			{
				WriteUserID(GetMyUserID(), ofs);
			}

			for (int i = 0; i < nCount ; ++i)
			{
				const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfoFromIndex(pGroup->GetID(), i);
				if (NULL != pUser)
				{
					WriteUserID(pUser->GetUserID(), ofs);
				}
			}
		}

		bFirst = FALSE;
	}

	ofs.close();
}

vector<IMPORT_GROUP>* FavoriteController::GetGroupInfoFromFile(HWND hParentWnd)
{
	if (m_bImport)
		return NULL;

	//Get File Name
	const CString strImportFileName = GetExportFileName(TRUE, _T(""), hParentWnd);
	if (strImportFileName.IsEmpty())
		return NULL;

	m_bImport = TRUE;
	// More Then 300 User Impossible
	if (300 <= ReadGroupInfoFromFileUserCount(strImportFileName))
	{
		NMessageBox(CWnd::GetDesktopWindow(), LoadStringFromResource(IDS_STRING632));
	}
	else
	{
		if (FALSE == ReadGroupInfoFromFile(strImportFileName, FALSE))
		{
			m_bImport = FALSE;
			m_ImportGroupVector.clear();
			return NULL;
		}
	}
	m_bImport = FALSE;

	return &m_ImportGroupVector;
}

void FavoriteController::ImportGroup()
{
	//Import ߺ   ʵ
	if (m_bImport)
		return;

	//Get File Name
	const CString strImportFileName = GetExportFileName(TRUE, _T(""));
	if (strImportFileName.IsEmpty())
		return;

	m_bImport = TRUE;
	// More Then 300 User Impossible
	if (300 <= ReadGroupInfoFromFileUserCount(strImportFileName))
	{
		NMessageBox(CWnd::GetDesktopWindow(), LoadStringFromResource(IDS_STRING632));
	}
	else
	{
		if (FALSE == ReadGroupInfoFromFile(strImportFileName))
		{
			m_bImport = FALSE;
			m_ImportGroupVector.clear();
			return;
		}
		g_pMessengerActor->RequestImportBuddy(m_ImportGroupVector);

	}
	m_bImport = FALSE;
}

const CString FavoriteController::GetExportFileName( BOOL bOpenFileDialog, CString strDefaultName, HWND hParentWnd )
{
	if (hParentWnd == NULL)
	{
		GetTreeCtrl()->GetParent();
	}
	TCHAR szCurrentPath[MAX_PATH];
	GetCurrentDirectory(MAX_PATH,szCurrentPath);

	CString strFileName(_T(""));

	TCHAR *szFilter = _T("Ntalkbiz list(*.nlist)|*.nlist||");
	CFileDialog exportSelectDialog(bOpenFileDialog, _T(".nlist"), strDefaultName, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter, CWnd::FromHandle(hParentWnd));

	CString caption;
	if (bOpenFileDialog)
	{
		//caption.LoadString(IDS_STRING_GROUP_IMPORT);
	}
	else
	{
	//	caption.LoadString(IDS_STRING_GROUP_EXPORT);
	}

	exportSelectDialog.m_ofn.lpstrTitle = caption;

	TCHAR strDocuments[MAX_PATH] = {0, };     
	HRESULT result = SHGetFolderPath(NULL, CSIDL_PERSONAL, NULL, SHGFP_TYPE_CURRENT, strDocuments);
	PathAppend(strDocuments, _T("\\Ntalk biz"));
	if (result == S_OK)
	{
		exportSelectDialog.m_ofn.lpstrInitialDir = strDocuments;
	}
	else
	{
	   //Set default path
		exportSelectDialog.m_ofn.lpstrInitialDir = GET_CONFIG()->GetRecvFolder();
	}

    GET_MESSENGER_DLG()->RegisterMfcModalDlg(&exportSelectDialog);
    int nResult = exportSelectDialog.DoModal();
    GET_MESSENGER_DLG()->UnRegisterMfcModalDlg(&exportSelectDialog);
    if (IDOK == nResult)
    {
		strFileName = exportSelectDialog.GetPathName();
	}

	SetCurrentDirectory(szCurrentPath);
	return strFileName;
}
int FavoriteController::ReadGroupInfoFromFileUserCount(const CString strImportFileName )
{
	int nUserTotalCount = 0;
	int nGroupcount = 0;
	ifstream ifs(strImportFileName, ios::binary);
	ifs.read((char *)&nGroupcount, sizeof(int));
	if (0 == nGroupcount)
		return (int)0;
	for (int i = 0; i < nGroupcount; ++i)
	{
		int nNameLength;
		ifs.read((char *)&nNameLength, sizeof(int));

		char *pGroupName = new char[nNameLength + 1];
		if (NULL == pGroupName)
			break;

		memset(pGroupName, 0, nNameLength + 1);
		ifs.read(pGroupName, nNameLength);
		delete [] pGroupName;
		int nUserCount;
		ifs.read((char *)&nUserCount, sizeof(int));
		nUserTotalCount = nUserCount + nUserTotalCount;
		for (int userIndex = 0; userIndex < nUserCount; ++userIndex)
		{
			int nUserIDLength;
			ifs.read((char *)&nUserIDLength, sizeof(int));

			char *pUserID = new char[nUserIDLength + 1];
			if (NULL == pUserID)
			{
				break;
			}
			memset(pUserID, 0, nUserIDLength + 1);
			ifs.read(pUserID, nUserIDLength);
			delete [] pUserID;
		}

	}
	ifs.close();

	return nUserTotalCount;
}


BOOL FavoriteController::ReadGroupInfoFromFile(const CString strImportFileName, BOOL bUseNewGroupName)
{
	BOOL bResult = TRUE;

	m_ImportGroupVector.clear();

	ifstream ifs(strImportFileName, ios::binary);

	int nGroupcount = 0;
	ifs.read((char *)&nGroupcount, sizeof(int));

	if (0 == nGroupcount)
		bResult = FALSE;


	for (int i = 0; i < nGroupcount; ++i)
	{
		int nNameLength;
		ifs.read((char *)&nNameLength, sizeof(int));

		char *pGroupName = new char[nNameLength + 1];
		if (NULL == pGroupName)
			break;

		memset(pGroupName, 0, nNameLength + 1);
		ifs.read(pGroupName, nNameLength);

		UINT nLen = MultiByteToWideChar(CP_ACP, 0, (LPCSTR)pGroupName, -1, NULL, 0);
		TCHAR *buf = new TCHAR[nLen];
		if (NULL == buf)
		{
			bResult = FALSE;
			delete [] pGroupName;
			break;
		}

		MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, (LPCSTR)pGroupName, -1, buf, nLen);

		IMPORT_GROUP group;
		CString strGroupName;
		strGroupName.Format(_T("%s"), buf);
		CString strNewGroupName = strGroupName;
		if (bUseNewGroupName)
		{
			strNewGroupName = GetNewGroupName(strGroupName);
		}
		
		group.strGroupName = strNewGroupName;
		

		delete [] buf;
		delete [] pGroupName;

		//Read user
		int nUserCount;
		ifs.read((char *)&nUserCount, sizeof(int));
		for (int userIndex = 0; userIndex < nUserCount; ++userIndex)
		{
			int nUserIDLength;
			ifs.read((char *)&nUserIDLength, sizeof(int));

			char *pUserID = new char[nUserIDLength + 1];
			if (NULL == pUserID)
			{
				bResult = FALSE;
				break;
			}

			memset(pUserID, 0, nUserIDLength + 1);
			ifs.read(pUserID, nUserIDLength);

			UINT nUserIDLen = MultiByteToWideChar(CP_ACP, 0, (LPCSTR)pUserID, -1, NULL, 0);
			TCHAR *userIDbuf = new TCHAR[nUserIDLen];
			if (NULL == userIDbuf)
			{
				bResult = FALSE;
				delete [] pUserID;
				break;
			}

			MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, (LPCSTR)pUserID, -1, userIDbuf, nUserIDLen);

			wstring userID(userIDbuf);

			if (FALSE == IsMyUserID(userID.c_str()))
				group.vecBuddyID.push_back(userID);				

			//ڱ ڽ ׷쿡 Ե ʵ Ѵ.

			delete [] userIDbuf;
			delete [] pUserID;

		}

		if (FALSE == bResult)
			break;

		m_ImportGroupVector.push_back(group);

	}

	ifs.close();

	return bResult;
}

void FavoriteController::GroupResort()
{
	m_favoriteView.GroupResort();
}

void FavoriteController::ResortBuddyInGroup(int nGroupID)
{
	m_favoriteView.ResortBuddyInGroup(nGroupID);
}

LPCWSTR FavoriteController::GetMyUserID()
{
	GT_MY_USER_DATA myUserData;
	g_pMessengerActor->GetMyUserInfo(myUserData);
	return myUserData.sMyPage.strUserID;
}

void FavoriteController::WriteUserID( LPCWSTR strID, ofstream &ofs )
{
	int nUserIDLength = WideCharToMultiByte( CP_ACP, 0, strID, -1, NULL, 0, NULL, NULL );
	char *userIDBuffer = new char[nUserIDLength + 1];
	WideCharToMultiByte( CP_ACP, 0, strID, -1, userIDBuffer, nUserIDLength, NULL, NULL );

	ofs.write((char*)&(nUserIDLength), sizeof(int));
	ofs.write(userIDBuffer, nUserIDLength);
	delete [] userIDBuffer;
}

void FavoriteController::SetCurrentChatBuddy(LPCWSTR strID)
{
	m_pCurrentChatBuddyController->SetCurrentChatBuddy(strID);

}

void FavoriteController::CheckEffectiveBubbys()
{
	deque<CString> result;
	for(int index = 0; index < m_Buddys.size(); index++)
	{
		const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfo(static_cast<CString>(m_Buddys[index]));
        if (NULL == pUser)
        {
            pUser = g_pMessengerActor->GetBuddyInfoFromPersist(static_cast<CString>(m_Buddys[index]));
        }
       // ASSERT(pUser);
		if(NULL == pUser)
		{
			continue;
		}
		result.push_front(static_cast<CString>(m_Buddys[index]));
		if(result.size() == 10 )
		{
			break;
		}
	}

	m_Buddys.clear();
	m_Buddys = result;
}

void FavoriteController::DeleteBuddyInDeque( LPCWSTR lpUserID )
{
	deque<CString>::iterator it = std::find(m_Buddys.begin(), m_Buddys.end(), CString(lpUserID));
	if(it != m_Buddys.end())
	{
		m_Buddys.erase(it);
	}
}

void FavoriteController::OnRButtonEvent( bool bDown, int nIndex )
{
	m_favoriteView.OnRButtonEvent(bDown, nIndex);
}

void FavoriteController::RequestRegiRecentGroupToPOI( LPCTSTR lpStr )
{
	vector<wstring> vecUsers;
	vecUsers.push_back(lpStr);
	g_pMessengerActor->RequestRegiFavoriteToPOI(vecUsers, REGPOIGROUP_RECENTCONTACTS);
}

void FavoriteController::RequestUnRegiRecentGroupToPOI( LPCTSTR lpStr )
{
	vector<wstring> vecUsers;
	vecUsers.push_back(lpStr);
	g_pMessengerActor->RequestUregFavoriteFromPOI(vecUsers, REGPOIGROUP_RECENTCONTACTS);
}








